

#include <stdio.h>
#include <stdlib.h>
#include <time.h>


typedef struct {														/*  Location node structure definition  */
		int nextNode_01, nextNode_02, nextNode_03;	
		int status, permission, x, y, z;
		} locationNode;


	
typedef struct {														/*  Car structure definition  */
		int currentNode;
		int x, y, z;
	} carNode;



void CarStartLocations(locationNode *, carNode *);						/*  Function declarations  */
void ChangeLights(locationNode *);
int NextNodeFunc(locationNode *, int);

int main(int argc, char* argv[])
{
	
	FILE *cfPtr = fopen("InnovationsOutput.mel", "a");					/*  File output setup  */
	
	
									
	
	
	int group = 1;
	int frame = 0, translate = 0;										/*  Variable declarations  */
	int vehicle = 1;
	int lightChange = 0;
	int carCount = 0;
	int temp_currentNode = 0;
	int temp_nextNode = 0;

	
	srand(time(NULL));													/*  Seed the random number generator  */

	locationNode node[20];												/*  Node definitions  */
	carNode car[4];
	


			

			node[0].nextNode_01 = -1;									/*  location node initialisation  */
			node[0].nextNode_02 = -1;
			node[0].nextNode_03 = -1;
			node[0].status = 0;
			node[0].permission = 0;
			node[0].x = 0;
			node[0].y = 0;
			node[0].z = -6;



			node[1].nextNode_01 = 3;
			node[1].nextNode_02 = -1;
			node[1].nextNode_03 = -1;
			node[1].status = 1;
			node[1].permission = 0;
			node[1].x = 2;
			node[1].y = 0;
			node[1].z = -6;



			node[2].nextNode_01 = 0;
			node[2].nextNode_02 = -1;
			node[2].nextNode_03 = -1;
			node[2].status = 0;
			node[2].permission = 0;
			node[2].x = 0;
			node[2].y = 0;
			node[2].z = -2;



			node[3].nextNode_01 = 8;
			node[3].nextNode_02 = 13;
			node[3].nextNode_03 = 12;
			node[3].status = 0;
			node[3].permission = 1;
			node[3].x = 2;
			node[3].y = 0;
			node[3].z = -2;



			node[4].nextNode_01 = 5;
			node[4].nextNode_02 = -1;
			node[4].nextNode_03 = -1;
			node[4].status = 1;
			node[4].permission = 0;
			node[4].x = -6;
			node[4].y = 0;
			node[4].z = 0;



			node[5].nextNode_01 = 2;
			node[5].nextNode_02 = 7;
			node[5].nextNode_03 = 13;
			node[5].status = 0;
			node[5].permission = 1;
			node[5].x = -2;
			node[5].y = 0;
			node[5].z = 0;



			node[6].nextNode_01 = 2;
			node[6].nextNode_02 = -1;
			node[6].nextNode_03 = -1;
			node[6].status = 0;
			node[6].permission = 0;
			node[6].x = 0;
			node[6].y = 0;
			node[6].z = 0;



			node[7].nextNode_01 = 8;
			node[7].nextNode_02 = -1;
			node[7].nextNode_03 = -1;
			node[7].status = 0;
			node[7].permission = 0;
			node[7].x = 2;
			node[7].y = 0;
			node[7].z = 0;



			node[8].nextNode_01 = 9;
			node[8].nextNode_02 = -1;
			node[8].nextNode_03 = -1;
			node[8].status = 0;
			node[8].permission = 0;
			node[8].x = 4;
			node[8].y = 0;
			node[8].z = 0;



			node[9].nextNode_01 = -1;
			node[9].nextNode_02 = -1;
			node[9].nextNode_03 = -1;
			node[9].status = 0;
			node[9].permission = 0;
			node[9].x = 8;
			node[9].y = 0;
			node[9].z = 0;



			node[10].nextNode_01 = -1;
			node[10].nextNode_02 = -1;
			node[10].nextNode_03 = -1;
			node[10].status = 0;
			node[10].permission = 0;
			node[10].x = -6;
			node[10].y = 0;
			node[10].z = 2;



			node[11].nextNode_01 = 10;
			node[11].nextNode_02 = -1;
			node[11].nextNode_03 = -1;
			node[11].status = 0;
			node[11].permission = 0;
			node[11].x = -2;
			node[11].y = 0;
			node[11].z = 2;



			node[12].nextNode_01 = 11;
			node[12].nextNode_02 = -1;
			node[12].nextNode_03 = -1;
			node[12].status = 0;
			node[12].permission = 0;
			node[12].x = 0;
			node[12].y = 0;
			node[12].z = 2;



			node[13].nextNode_01 = 17;
			node[13].nextNode_02 = -1;
			node[13].nextNode_03 = -1;
			node[13].status = 0;
			node[13].permission = 0;
			node[13].x = 2;
			node[13].y = 0;
			node[13].z = 2;



			node[14].nextNode_01 = 17;
			node[14].nextNode_02 = 12;
			node[14].nextNode_03 = 6;
			node[14].status = 0;
			node[14].permission = 1;
			node[14].x = 4;
			node[14].y = 0;
			node[14].z = 2;



			node[15].nextNode_01 = 14;
			node[15].nextNode_02 = -1;
			node[15].nextNode_03 = -1;
			node[15].status = 1;
			node[15].permission = 0;
			node[15].x = 8;
			node[15].y = 0;
			node[15].z = 2;



			node[16].nextNode_01 = 11;
			node[16].nextNode_02 = 6;
			node[16].nextNode_03 = 7;
			node[16].status = 0;
			node[16].permission = 0;
			node[16].x = 0;
			node[16].y = 0;
			node[16].z = 4;



			node[17].nextNode_01 = 19;
			node[17].nextNode_02 = -1;
			node[17].nextNode_03 = -1;
			node[17].status = 0;
			node[17].permission = 0;
			node[17].x = 2;
			node[17].y = 0;
			node[17].z = 4;



			node[18].nextNode_01 = 16;
			node[18].nextNode_02 = -1;
			node[18].nextNode_03 = -1;
			node[18].status = 1;
			node[18].permission = 0;
			node[18].x = 0;
			node[18].y = 0;
			node[18].z = 8;



			node[19].nextNode_01 = -1;
			node[19].nextNode_02 = -1;
			node[19].nextNode_03 = -1;
			node[19].status = 0;
			node[19].permission = 0;
			node[19].x = 2;
			node[19].y = 0;
			node[19].z = 8;

		
	CarStartLocations(node, car);										/*  Assign car start locations  */

	ChangeLights(node);													/*  Assign traffic light node permissions  */
	
	
	for(frame=0; frame<=1000; frame+=50){								/*  Increment through frames, 50 at a time  */
		

		fprintf(cfPtr, "currentTime %dpal;\n", frame);
		
		if(frame == 0){													/*  If the current frame is 0  */

			for(carCount= 0; carCount<=3; carCount++){					/*  Increment through each car  */

					fprintf(cfPtr, "setKeyframe -value %d car_%d.translateX;\n", car[carCount].x, carCount);		/*  Keyframe car's start position  */
					fprintf(cfPtr, "setKeyframe -value %d car_%d.translateY;\n", car[carCount].y, carCount);
					fprintf(cfPtr, "setKeyframe -value %d car_%d.translateZ;\n", car[carCount].z, carCount);

			}
		}

		else

			if(frame >=50){


			lightChange = frame % 200;										/*  Check if 200 frames have passed, which would result in lightChange equalling 0  */
	
			if(lightChange==0)												/*  If 200 frames have passed, change traffic light node permission values  */
			
				ChangeLights(node);  
		
			for(carCount= 0; carCount<=3; carCount++){						/* Increment through each car  */
			

				temp_currentNode = car[carCount].currentNode;				/*  Assign temporary current node value  */
				temp_nextNode = NextNodeFunc(node, temp_currentNode);		/*  Assign temporary next node value  */
			
			
				if(temp_nextNode != -1){									/*  If the nextNode is equal to -1, then it is null  */
			
				
					if(node[temp_currentNode].permission == 0 && node[temp_nextNode].status == 0){			/*  if the current location node's permission and status are equal to 0  */
			
				
						
						
						node[temp_currentNode].status = 0;													/*  Change the current location node's status to 0  */
						car[carCount].currentNode = temp_nextNode;											/*  Change car's current location node to the current location node's next node  */
						temp_currentNode = car[carCount].currentNode;										/*  Assign temporary current node with new current node value  */
						car[carCount].x = node[temp_currentNode].x;											/*  Assign new x, y, z values to the car node  */
						car[carCount].y = node[temp_currentNode].y;
						car[carCount].z = node[temp_currentNode].z;
						node[temp_currentNode].status = 1;													/*  Change the current location node's status to 1  */
							

						fprintf(cfPtr, "setKeyframe -value %d car_%d.translateX;\n", car[carCount].x, carCount);
						fprintf(cfPtr, "setKeyframe -value %d car_%d.translateY;\n", car[carCount].y, carCount);
						fprintf(cfPtr, "setKeyframe -value %d car_%d.translateZ;\n", car[carCount].z, carCount);


						}

					else {

						fprintf(cfPtr, "setKeyframe -value %d car_%d.translateX;\n", car[carCount].x, carCount);		/*  If the car cannot be moved, keyframe the car's current location  */
						fprintf(cfPtr, "setKeyframe -value %d car_%d.translateY;\n", car[carCount].y, carCount);
						fprintf(cfPtr, "setKeyframe -value %d car_%d.translateZ;\n", car[carCount].z, carCount);	

					}

				}	
					
			}
			}	
	
	}  




	printf("Keyframe generation complete\n\nLoad the InnovationsOutput.mel file into the Maya script editor\n\n");

	return 0;
}

	
	
	
	void CarStartLocations(locationNode *node, carNode *car)			/*  Pre set car start locations  */
   {									
		

		
		car[0].currentNode = 1;
		car[0].x = node[1].x;
		car[0].y = node[1].y;
		car[0].z = node[1].z;
		

		car[1].currentNode = 4;
		car[1].x = node[4].x;
		car[1].y = node[4].y;
		car[1].z = node[4].z;

		car[2].currentNode = 15;
		car[2].x = node[15].x;
		car[2].y = node[15].y;
		car[2].z = node[15].z;
	
		car[3].currentNode = 18;
		car[3].x = node[18].x;
		car[3].y = node[18].y;
		car[3].z = node[18].z;

		
	
	}										
		
		

	void ChangeLights(locationNode *node)								/*  Change traffic lights  */
   {									
		if(node[3].permission == 0){
			node[3].permission = 1;
			node[5].permission = 1;
			node[14].permission = 1;
			node[16].permission = 0;
			}

			else
				if(node[16].permission == 0){
					node[3].permission = 1;
					node[5].permission = 1;
					node[14].permission = 0;
					node[16].permission = 1;
					}

					else
						if(node[14].permission == 0){
							node[3].permission = 1;
							node[5].permission = 0;
							node[14].permission = 1;
							node[16].permission = 1;
							}

							else{
								node[3].permission = 0;
								node[5].permission = 1;
								node[14].permission = 1;
								node[16].permission = 1;
								}

		
   }


	int NextNodeFunc(locationNode *node, int temp_currentNode)			/*  Random next location node choice  */
	{
		int choice;
		
		if(node[temp_currentNode].nextNode_02 == -1)

			return node[temp_currentNode].nextNode_01;

		else
		{
			choice = 1 + (rand() % 3);

			switch (choice){

			case 1:

				return node[temp_currentNode].nextNode_03;

			case 2:

				return node[temp_currentNode].nextNode_02;

			case 3:

				return node[temp_currentNode].nextNode_01;

			}
		}

	}